# notehub-py
The OpenAPI definition for the Notehub.io API.


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.2.0
- Package version: 1.0.12
- Generator version: 7.5.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://dev.blues.io/support/](https://dev.blues.io/support/)

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

With `pip` via PyPy:

```sh
python3 -m pip install notehub-py
```
(you may need to run `pip` with root permission: `sudo python3 -m pip install notehub-py`)

or

```sh
python3 -m pip3 install notehub-py
```

Then import the package:

```python
import notehub_py
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import notehub_py
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import notehub_py
from notehub_py.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.notefile.net
# See configuration.py for a list of all supported configuration parameters.
configuration = notehub_py.Configuration(
    host = "https://api.notefile.net"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: api_key
configuration.api_key['api_key'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['api_key'] = 'Bearer'


# Enter a context with an instance of the API client
with notehub_py.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = notehub_py.AlertApi(api_client)
    project_uid = 'app:2606f411-dea6-44a0-9743-1130f57d77d8' # str | 
    page_size = 50 # int |  (optional) (default to 50)
    page_num = 1 # int |  (optional) (default to 1)
    monitor_uid = 'monitor_uid_example' # str |  (optional)

    try:
        api_response = api_instance.get_alerts(project_uid, page_size=page_size, page_num=page_num, monitor_uid=monitor_uid)
        print("The response of AlertApi->get_alerts:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AlertApi->get_alerts: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.notefile.net*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AlertApi* | [**get_alerts**](docs/AlertApi.md#get_alerts) | **GET** /v1/projects/{projectUID}/alerts | 
*AuthorizationApi* | [**login**](docs/AuthorizationApi.md#login) | **POST** /auth/login | 
*BillingAccountApi* | [**get_billing_accounts**](docs/BillingAccountApi.md#get_billing_accounts) | **GET** /v1/billing-accounts | 
*DeviceApi* | [**delete_device_environment_variable**](docs/DeviceApi.md#delete_device_environment_variable) | **DELETE** /v1/projects/{projectUID}/devices/{deviceUID}/environment_variables/{key} | 
*DeviceApi* | [**delete_project_device**](docs/DeviceApi.md#delete_project_device) | **DELETE** /v1/projects/{projectUID}/devices/{deviceUID} | 
*DeviceApi* | [**disable_device**](docs/DeviceApi.md#disable_device) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/disable | 
*DeviceApi* | [**disable_device_connectivity_assurance**](docs/DeviceApi.md#disable_device_connectivity_assurance) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/disable-connectivity-assurance | 
*DeviceApi* | [**enable_device**](docs/DeviceApi.md#enable_device) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/enable | 
*DeviceApi* | [**enable_device_connectivity_assurance**](docs/DeviceApi.md#enable_device_connectivity_assurance) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/enable-connectivity-assurance | 
*DeviceApi* | [**get_device**](docs/DeviceApi.md#get_device) | **GET** /v1/projects/{projectUID}/devices/{deviceUID} | 
*DeviceApi* | [**get_device_environment_variables**](docs/DeviceApi.md#get_device_environment_variables) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/environment_variables | 
*DeviceApi* | [**get_device_environment_variables_by_pin**](docs/DeviceApi.md#get_device_environment_variables_by_pin) | **GET** /v1/products/{productUID}/devices/{deviceUID}/environment_variables_with_pin | 
*DeviceApi* | [**get_device_health_log**](docs/DeviceApi.md#get_device_health_log) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/health-log | 
*DeviceApi* | [**get_device_latest**](docs/DeviceApi.md#get_device_latest) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/latest | 
*DeviceApi* | [**get_device_public_key**](docs/DeviceApi.md#get_device_public_key) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/public-key | 
*DeviceApi* | [**get_device_sessions**](docs/DeviceApi.md#get_device_sessions) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/sessions | 
*DeviceApi* | [**get_project_device_public_keys**](docs/DeviceApi.md#get_project_device_public_keys) | **GET** /v1/projects/{projectUID}/devices/public-keys | 
*DeviceApi* | [**get_project_devices**](docs/DeviceApi.md#get_project_devices) | **GET** /v1/projects/{projectUID}/devices | 
*DeviceApi* | [**get_project_fleet_devices**](docs/DeviceApi.md#get_project_fleet_devices) | **GET** /v1/projects/{projectUID}/fleets/{fleetUID}/devices | 
*DeviceApi* | [**handle_note_add**](docs/DeviceApi.md#handle_note_add) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/notes/{notefileID} | 
*DeviceApi* | [**handle_note_changes**](docs/DeviceApi.md#handle_note_changes) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/notes/{notefileID}/changes | 
*DeviceApi* | [**handle_note_create_add**](docs/DeviceApi.md#handle_note_create_add) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/notes/{notefileID}/{noteID} | 
*DeviceApi* | [**handle_note_delete**](docs/DeviceApi.md#handle_note_delete) | **DELETE** /v1/projects/{projectUID}/devices/{deviceUID}/notes/{notefileID}/{noteID} | 
*DeviceApi* | [**handle_note_get**](docs/DeviceApi.md#handle_note_get) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/notes/{notefileID}/{noteID} | 
*DeviceApi* | [**handle_note_signal**](docs/DeviceApi.md#handle_note_signal) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/signal | 
*DeviceApi* | [**handle_note_update**](docs/DeviceApi.md#handle_note_update) | **PUT** /v1/projects/{projectUID}/devices/{deviceUID}/notes/{notefileID}/{noteID} | 
*DeviceApi* | [**handle_notefile_changes**](docs/DeviceApi.md#handle_notefile_changes) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/files/changes | 
*DeviceApi* | [**handle_notefile_changes_pending**](docs/DeviceApi.md#handle_notefile_changes_pending) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/files/changes/pending | 
*DeviceApi* | [**handle_notefile_delete**](docs/DeviceApi.md#handle_notefile_delete) | **DELETE** /v1/projects/{projectUID}/devices/{deviceUID}/files | 
*DeviceApi* | [**post_provision_project_device**](docs/DeviceApi.md#post_provision_project_device) | **POST** /v1/projects/{projectUID}/devices/{deviceUID}/provision | 
*DeviceApi* | [**put_device_environment_variables**](docs/DeviceApi.md#put_device_environment_variables) | **PUT** /v1/projects/{projectUID}/devices/{deviceUID}/environment_variables | 
*DeviceApi* | [**put_device_environment_variables_by_pin**](docs/DeviceApi.md#put_device_environment_variables_by_pin) | **PUT** /v1/products/{productUID}/devices/{deviceUID}/environment_variables_with_pin | 
*EventApi* | [**get_fleet_events**](docs/EventApi.md#get_fleet_events) | **GET** /v1/projects/{projectUID}/fleets/{fleetUID}/events | 
*EventApi* | [**get_fleet_events_by_cursor**](docs/EventApi.md#get_fleet_events_by_cursor) | **GET** /v1/projects/{projectUID}/fleets/{fleetUID}/events-cursor | 
*EventApi* | [**get_project_events**](docs/EventApi.md#get_project_events) | **GET** /v1/projects/{projectUID}/events | 
*EventApi* | [**get_project_events_by_cursor**](docs/EventApi.md#get_project_events_by_cursor) | **GET** /v1/projects/{projectUID}/events-cursor | 
*EventApi* | [**get_route_logs_by_event**](docs/EventApi.md#get_route_logs_by_event) | **GET** /v1/projects/{projectUID}/events/{eventUID}/route-logs | 
*MonitorApi* | [**create_monitor**](docs/MonitorApi.md#create_monitor) | **POST** /v1/projects/{projectUID}/monitors | 
*MonitorApi* | [**delete_monitor**](docs/MonitorApi.md#delete_monitor) | **DELETE** /v1/projects/{projectUID}/monitors/{monitorUID} | 
*MonitorApi* | [**get_monitor**](docs/MonitorApi.md#get_monitor) | **GET** /v1/projects/{projectUID}/monitors/{monitorUID} | 
*MonitorApi* | [**get_monitors**](docs/MonitorApi.md#get_monitors) | **GET** /v1/projects/{projectUID}/monitors | 
*MonitorApi* | [**update_monitor**](docs/MonitorApi.md#update_monitor) | **PUT** /v1/projects/{projectUID}/monitors/{monitorUID} | 
*ProjectApi* | [**clone_project**](docs/ProjectApi.md#clone_project) | **POST** /v1/projects/{projectUID}/clone | 
*ProjectApi* | [**create_fleet**](docs/ProjectApi.md#create_fleet) | **POST** /v1/projects/{projectUID}/fleets | 
*ProjectApi* | [**create_product**](docs/ProjectApi.md#create_product) | **POST** /v1/projects/{projectUID}/products | 
*ProjectApi* | [**create_project**](docs/ProjectApi.md#create_project) | **POST** /v1/projects | 
*ProjectApi* | [**delete_device_fleets**](docs/ProjectApi.md#delete_device_fleets) | **DELETE** /v1/projects/{projectUID}/devices/{deviceUID}/fleets | 
*ProjectApi* | [**delete_fleet**](docs/ProjectApi.md#delete_fleet) | **DELETE** /v1/projects/{projectUID}/fleets/{fleetUID} | 
*ProjectApi* | [**delete_fleet_environment_variable**](docs/ProjectApi.md#delete_fleet_environment_variable) | **DELETE** /v1/projects/{projectUID}/fleets/{fleetUID}/environment_variables/{key} | 
*ProjectApi* | [**delete_project**](docs/ProjectApi.md#delete_project) | **DELETE** /v1/projects/{projectUID} | 
*ProjectApi* | [**delete_project_environment_variable**](docs/ProjectApi.md#delete_project_environment_variable) | **DELETE** /v1/projects/{projectUID}/environment_variables/{key} | 
*ProjectApi* | [**dfu_action**](docs/ProjectApi.md#dfu_action) | **POST** /v1/projects/{projectUID}/dfu/{firmwareType}/{action} | 
*ProjectApi* | [**disable_global_transformation**](docs/ProjectApi.md#disable_global_transformation) | **POST** /v1/projects/{projectUID}/global-transformation/disable | 
*ProjectApi* | [**enable_global_transformation**](docs/ProjectApi.md#enable_global_transformation) | **POST** /v1/projects/{projectUID}/global-transformation/enable | 
*ProjectApi* | [**get_device_dfu_history**](docs/ProjectApi.md#get_device_dfu_history) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/dfu/{firmwareType}/history | 
*ProjectApi* | [**get_device_dfu_status**](docs/ProjectApi.md#get_device_dfu_status) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/dfu/{firmwareType}/status | 
*ProjectApi* | [**get_device_fleets**](docs/ProjectApi.md#get_device_fleets) | **GET** /v1/projects/{projectUID}/devices/{deviceUID}/fleets | 
*ProjectApi* | [**get_devices_dfu_history**](docs/ProjectApi.md#get_devices_dfu_history) | **GET** /v1/projects/{projectUID}/dfu/{firmwareType}/history | 
*ProjectApi* | [**get_devices_dfu_status**](docs/ProjectApi.md#get_devices_dfu_status) | **GET** /v1/projects/{projectUID}/dfu/{firmwareType}/status | 
*ProjectApi* | [**get_firmware_info**](docs/ProjectApi.md#get_firmware_info) | **GET** /v1/projects/{projectUID}/firmware | 
*ProjectApi* | [**get_fleet**](docs/ProjectApi.md#get_fleet) | **GET** /v1/projects/{projectUID}/fleets/{fleetUID} | 
*ProjectApi* | [**get_fleet_environment_variables**](docs/ProjectApi.md#get_fleet_environment_variables) | **GET** /v1/projects/{projectUID}/fleets/{fleetUID}/environment_variables | 
*ProjectApi* | [**get_notefile_schemas**](docs/ProjectApi.md#get_notefile_schemas) | **GET** /v1/projects/{projectUID}/schemas | Get variable format for a notefile
*ProjectApi* | [**get_project**](docs/ProjectApi.md#get_project) | **GET** /v1/projects/{projectUID} | 
*ProjectApi* | [**get_project_by_product**](docs/ProjectApi.md#get_project_by_product) | **GET** /v1/products/{productUID}/project | 
*ProjectApi* | [**get_project_environment_variables**](docs/ProjectApi.md#get_project_environment_variables) | **GET** /v1/projects/{projectUID}/environment_variables | 
*ProjectApi* | [**get_project_fleets**](docs/ProjectApi.md#get_project_fleets) | **GET** /v1/projects/{projectUID}/fleets | 
*ProjectApi* | [**get_project_members**](docs/ProjectApi.md#get_project_members) | **GET** /v1/projects/{projectUID}/members | 
*ProjectApi* | [**get_project_products**](docs/ProjectApi.md#get_project_products) | **GET** /v1/projects/{projectUID}/products | 
*ProjectApi* | [**get_projects**](docs/ProjectApi.md#get_projects) | **GET** /v1/projects | 
*ProjectApi* | [**put_device_fleets**](docs/ProjectApi.md#put_device_fleets) | **PUT** /v1/projects/{projectUID}/devices/{deviceUID}/fleets | 
*ProjectApi* | [**put_fleet_environment_variables**](docs/ProjectApi.md#put_fleet_environment_variables) | **PUT** /v1/projects/{projectUID}/fleets/{fleetUID}/environment_variables | 
*ProjectApi* | [**put_project_environment_variables**](docs/ProjectApi.md#put_project_environment_variables) | **PUT** /v1/projects/{projectUID}/environment_variables | 
*ProjectApi* | [**set_global_transformation**](docs/ProjectApi.md#set_global_transformation) | **POST** /v1/projects/{projectUID}/global-transformation | 
*ProjectApi* | [**update_fleet**](docs/ProjectApi.md#update_fleet) | **PUT** /v1/projects/{projectUID}/fleets/{fleetUID} | 
*ProjectApi* | [**upload_firmware**](docs/ProjectApi.md#upload_firmware) | **PUT** /v1/projects/{projectUID}/firmware/{firmwareType}/{filename} | 
*RepositoryApi* | [**create_repository**](docs/RepositoryApi.md#create_repository) | **POST** /v1/repositories | 
*RepositoryApi* | [**create_repository_dataset**](docs/RepositoryApi.md#create_repository_dataset) | **PUT** /v1/repositories/{repositoryUID}/datasets | 
*RepositoryApi* | [**delete_repository**](docs/RepositoryApi.md#delete_repository) | **DELETE** /v1/repositories/{repositoryUID} | 
*RepositoryApi* | [**delete_repository_dataset**](docs/RepositoryApi.md#delete_repository_dataset) | **DELETE** /v1/repositories/{repositoryUID}/datasets/{name} | 
*RepositoryApi* | [**get_repository**](docs/RepositoryApi.md#get_repository) | **GET** /v1/repositories/{repositoryUID} | 
*RepositoryApi* | [**get_repository_data**](docs/RepositoryApi.md#get_repository_data) | **GET** /v1/repositories/{repositoryUID}/data | 
*RepositoryApi* | [**get_repository_dataset**](docs/RepositoryApi.md#get_repository_dataset) | **GET** /v1/repositories/{repositoryUID}/datasets/{name} | 
*RepositoryApi* | [**put_repository**](docs/RepositoryApi.md#put_repository) | **PUT** /v1/repositories/{repositoryUID} | 
*RepositoryApi* | [**query_repository_dataset**](docs/RepositoryApi.md#query_repository_dataset) | **GET** /v1/repositories/{repositoryUID}/datasets/{name}/query | 
*RepositoryApi* | [**query_repository_sql**](docs/RepositoryApi.md#query_repository_sql) | **POST** /v1/repositories/{repositoryUID}/sql | 
*RouteApi* | [**create_route**](docs/RouteApi.md#create_route) | **POST** /v1/projects/{projectUID}/routes | 
*RouteApi* | [**delete_route**](docs/RouteApi.md#delete_route) | **DELETE** /v1/projects/{projectUID}/routes/{routeUID} | 
*RouteApi* | [**get_route**](docs/RouteApi.md#get_route) | **GET** /v1/projects/{projectUID}/routes/{routeUID} | 
*RouteApi* | [**get_route_logs_by_route**](docs/RouteApi.md#get_route_logs_by_route) | **GET** /v1/projects/{projectUID}/routes/{routeUID}/route-logs | 
*RouteApi* | [**get_routes**](docs/RouteApi.md#get_routes) | **GET** /v1/projects/{projectUID}/routes | 
*RouteApi* | [**update_route**](docs/RouteApi.md#update_route) | **PUT** /v1/projects/{projectUID}/routes/{routeUID} | 


## Documentation For Models

 - [Alert](docs/Alert.md)
 - [AlertDataInner](docs/AlertDataInner.md)
 - [AlertNotificationsInner](docs/AlertNotificationsInner.md)
 - [Aws](docs/Aws.md)
 - [Azure](docs/Azure.md)
 - [BillingAccount](docs/BillingAccount.md)
 - [BillingAccountRole](docs/BillingAccountRole.md)
 - [Body](docs/Body.md)
 - [CloneProjectRequest](docs/CloneProjectRequest.md)
 - [Contact](docs/Contact.md)
 - [CreateFleetRequest](docs/CreateFleetRequest.md)
 - [CreateMonitor](docs/CreateMonitor.md)
 - [CreateProductRequest](docs/CreateProductRequest.md)
 - [CreateProjectRequest](docs/CreateProjectRequest.md)
 - [CreateUpdateRepository](docs/CreateUpdateRepository.md)
 - [CurrentFirmware](docs/CurrentFirmware.md)
 - [DFUEnv](docs/DFUEnv.md)
 - [DFUState](docs/DFUState.md)
 - [DataField](docs/DataField.md)
 - [DataSet](docs/DataSet.md)
 - [DataSetField](docs/DataSetField.md)
 - [DeleteDeviceFleetsRequest](docs/DeleteDeviceFleetsRequest.md)
 - [Device](docs/Device.md)
 - [DeviceDfuHistory](docs/DeviceDfuHistory.md)
 - [DeviceDfuHistoryPage](docs/DeviceDfuHistoryPage.md)
 - [DeviceDfuStateMachine](docs/DeviceDfuStateMachine.md)
 - [DeviceDfuStateMachineNode](docs/DeviceDfuStateMachineNode.md)
 - [DeviceDfuStatus](docs/DeviceDfuStatus.md)
 - [DeviceDfuStatusCurrent](docs/DeviceDfuStatusCurrent.md)
 - [DeviceDfuStatusPage](docs/DeviceDfuStatusPage.md)
 - [DeviceSession](docs/DeviceSession.md)
 - [DeviceTowerInfo](docs/DeviceTowerInfo.md)
 - [DeviceUsage](docs/DeviceUsage.md)
 - [DfuActionRequest](docs/DfuActionRequest.md)
 - [EmailNotification](docs/EmailNotification.md)
 - [EnvironmentVariables](docs/EnvironmentVariables.md)
 - [Error](docs/Error.md)
 - [Event](docs/Event.md)
 - [Firmware](docs/Firmware.md)
 - [FirmwareInfo](docs/FirmwareInfo.md)
 - [Fleet](docs/Fleet.md)
 - [GetAlerts200Response](docs/GetAlerts200Response.md)
 - [GetBillingAccounts200Response](docs/GetBillingAccounts200Response.md)
 - [GetDeviceEnvironmentVariables200Response](docs/GetDeviceEnvironmentVariables200Response.md)
 - [GetDeviceHealthLog200Response](docs/GetDeviceHealthLog200Response.md)
 - [GetDeviceHealthLog200ResponseHealthLogInner](docs/GetDeviceHealthLog200ResponseHealthLogInner.md)
 - [GetDeviceLatest200Response](docs/GetDeviceLatest200Response.md)
 - [GetDevicePublicKey200Response](docs/GetDevicePublicKey200Response.md)
 - [GetDeviceSessions200Response](docs/GetDeviceSessions200Response.md)
 - [GetProjectDevicePublicKeys200Response](docs/GetProjectDevicePublicKeys200Response.md)
 - [GetProjectDevicePublicKeys200ResponseDevicePublicKeysInner](docs/GetProjectDevicePublicKeys200ResponseDevicePublicKeysInner.md)
 - [GetProjectDevices200Response](docs/GetProjectDevices200Response.md)
 - [GetProjectEvents200Response](docs/GetProjectEvents200Response.md)
 - [GetProjectEventsByCursor200Response](docs/GetProjectEventsByCursor200Response.md)
 - [GetProjectFleets200Response](docs/GetProjectFleets200Response.md)
 - [GetProjectMembers200Response](docs/GetProjectMembers200Response.md)
 - [GetProjectProducts200Response](docs/GetProjectProducts200Response.md)
 - [GetProjects200Response](docs/GetProjects200Response.md)
 - [GetRouteLogsByRoute200ResponseInner](docs/GetRouteLogsByRoute200ResponseInner.md)
 - [Google](docs/Google.md)
 - [HandleNoteChanges200Response](docs/HandleNoteChanges200Response.md)
 - [HandleNoteGet200Response](docs/HandleNoteGet200Response.md)
 - [HandleNoteSignal200Response](docs/HandleNoteSignal200Response.md)
 - [HandleNotefileChanges200Response](docs/HandleNotefileChanges200Response.md)
 - [HandleNotefileChangesPending200Response](docs/HandleNotefileChangesPending200Response.md)
 - [HandleNotefileDeleteRequest](docs/HandleNotefileDeleteRequest.md)
 - [Http](docs/Http.md)
 - [HttpFilter](docs/HttpFilter.md)
 - [HttpTransform](docs/HttpTransform.md)
 - [Location](docs/Location.md)
 - [Login200Response](docs/Login200Response.md)
 - [LoginRequest](docs/LoginRequest.md)
 - [Monitor](docs/Monitor.md)
 - [MonitorAlertRoutesInner](docs/MonitorAlertRoutesInner.md)
 - [Mqtt](docs/Mqtt.md)
 - [Note](docs/Note.md)
 - [NotefileSchema](docs/NotefileSchema.md)
 - [NotehubRoute](docs/NotehubRoute.md)
 - [NotehubRouteSchema](docs/NotehubRouteSchema.md)
 - [PostProvisionProjectDeviceRequest](docs/PostProvisionProjectDeviceRequest.md)
 - [Product](docs/Product.md)
 - [Project](docs/Project.md)
 - [ProjectMember](docs/ProjectMember.md)
 - [Proxy](docs/Proxy.md)
 - [PutDeviceFleetsRequest](docs/PutDeviceFleetsRequest.md)
 - [QuestionDataResponseLineChart](docs/QuestionDataResponseLineChart.md)
 - [QuestionDataResponseMap](docs/QuestionDataResponseMap.md)
 - [Radresponder](docs/Radresponder.md)
 - [Repository](docs/Repository.md)
 - [Role](docs/Role.md)
 - [SchemaProperty](docs/SchemaProperty.md)
 - [SimUsage](docs/SimUsage.md)
 - [Slack](docs/Slack.md)
 - [SlackBearerNotification](docs/SlackBearerNotification.md)
 - [SlackWebHookNotification](docs/SlackWebHookNotification.md)
 - [Snowflake](docs/Snowflake.md)
 - [SnowflakeTransform](docs/SnowflakeTransform.md)
 - [Thingworx](docs/Thingworx.md)
 - [TowerLocation](docs/TowerLocation.md)
 - [Twilio](docs/Twilio.md)
 - [UpdateFleetRequest](docs/UpdateFleetRequest.md)
 - [UploadMetadata](docs/UploadMetadata.md)
 - [UserDbRoute](docs/UserDbRoute.md)
 - [UserDfuStateMachine](docs/UserDfuStateMachine.md)
 - [UserDfuStateMachineStatus](docs/UserDfuStateMachineStatus.md)
 - [UserFirmwareInfo](docs/UserFirmwareInfo.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: X-Session-Token
- **Location**: HTTP header

<a id="pin"></a>
### pin

- **Type**: API key
- **API key parameter name**: X-Auth-Token
- **Location**: HTTP header


## Author

engineering@blues.io


